package jpatp.callback;


import java.util.List;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityTransaction;

public class Client {
    private EntityManagerFactory factory;
    private EntityManager manager;

    public Client() {}

    public void testRun() {

        // get EntityManager
        factory = Persistence.createEntityManagerFactory("em1");
        manager = factory.createEntityManager();

        // get transaction
        EntityTransaction transaction = manager.getTransaction();

        try{

            // transaction begins
            transaction.begin();

            final TestEntity TEM2 = new TestEntity();
            TEM2.setName("YOKOYOKO");
            TEM2.setId((long)2);
            manager.persist(TEM2);

            // commit transaction
            transaction.commit();

// ---------------------------------------------------

            transaction.begin();

            TEM2.setName("YOKOTA");

            transaction.commit();

// ---------------------------------------------------

            transaction.begin();

            Query query = manager.createNamedQuery("testQuery");
            List<TestEntity> results = PersonEntities.<TestEntity> getList(query.getResultList());
/*
            for(TestEntity test : results) {
                System.out.println("### id = " + test.getId() + " Name = " + test.getName());
            }
*/
            transaction.commit();

// ---------------------------------------------------

            transaction.begin();

            manager.remove(TEM2);

            transaction.commit();


        }
        catch(Throwable th){
            System.err.println("### Unexpected exception occured.");
            System.err.println("### " + th.getMessage());
            th.printStackTrace();
            if (transaction != null && transaction.isActive()){
                transaction.rollback();
            }
        }
        finally{
            // close EntityManager
            if (manager != null && manager.isOpen()){
                manager.close();
            }
            // close EntityManagerFactory
            if (factory != null && factory.isOpen()){
                factory.close();
            }
        }
    }

    public static void main(String[] args) {
        Client testMain = new Client();
        testMain.testRun();
    }
}
